//***************************************************************************
//* LANIOCu wb_t@C
//***************************************************************************

#ifdef EXPORT_DECLSPEC
#define DECLSPEC extern "C" __declspec(dllexport) int __stdcall
#else
#define DECLSPEC extern "C" __declspec(dllimport) int __stdcall
#endif

//***************************************************************************
//* ^`A萔`
//***************************************************************************

//***************************************************************************
//* LANIOnh
//***************************************************************************
#define hLANIO int

//***************************************************************************
//* LELanioGetLastErrorԂG[R[h
//***************************************************************************
enum LANIOERROR {
	LELANIOERR_NOINIT = 1,			//* Ă܂BLELanioInitsĂB
	LELANIOERR_NOLANIO,				//* ʁALANIOł܂łB
	LELANIOERR_NOTEXIST,			//* ŔLANIO葽lw肵܂B
	LELANIOERR_NOTFOUND,			//* w肳ꂽLANIO𔭌ł܂łB
	LELANIOERR_NOCONNECTED,			//* LANIOƐڑĂ܂BLELanioConnectsĂB
	LELANIOERR_INVALIDOPERATION,	//* w肳ꂽ͎sł܂B
	LELANIOERR_ALREADY_CONNECTED,	//* łɐڑĂ܂B
	LELANIOERR_OVERCONNECTMAX,		//* ڑő吔𒴉߂܂B
};

//***************************************************************************
//* LELanioGetModelŎ擾LANIOf
//***************************************************************************
enum LANIOMODEL {
	NOTLANIO = 0,
	LA3R2P = 1,		// LA-3R2P-P܂
	LA7P   = 2,		// LA-7P-P / LA-7P-A܂
	LA5R   = 3,
	LA5T2S = 4,		// LA-5T2S-P܂
	LA5PP  = 5,
	NO_GETMODEL = -1,
};

//***************************************************************************
//* AIAG[擾֐
//***************************************************************************

//***************************************************************************
//*		LANIOCu܂B
//***************************************************************************
DECLSPEC LELanioInit();

//***************************************************************************
//*		LANIOCu̎gpI܂B
//***************************************************************************
DECLSPEC LELanioEnd();

//***************************************************************************
//*		OɔG[ԍ擾܂B
//*		߂l : G[̏Ԃ܂
//***************************************************************************
DECLSPEC LELanioGetLastError();

//***************************************************************************
//* LANIO֐
//***************************************************************************

//***************************************************************************
//*		ILANIOIDModel擾@\ɂĂ̐ݒ܂B
//*		   : enable  ̋@\gpꍇTRUE(1)AȂꍇFALSE(0)
//*		         port    IDModel擾VÃ|[gԍ
//***************************************************************************
DECLSPEC LELanioSetAutoRequestIdModel(BOOL enable, int port);

//***************************************************************************
//*		LANɂLANIO܂B
//*		   : msec    ^CAEgԁiP mbj
//*		߂l : LANIO̐BłȂꍇ0BG[-1
//***************************************************************************
DECLSPEC LELanioSearch(int msec = 100);

//***************************************************************************
//* LANIO擾֐
//***************************************************************************

//***************************************************************************
//*		LANIOIPAhX擾܂B
//*		   : lanio       LANIOԍ
//*		         ipaddress   IPAhX擾obt@ւ̃|C^(16byteKv)
//***************************************************************************
DECLSPEC LELanioGetIpAddress(int lanio, char *ipaddress);

//***************************************************************************
//*		LANIOMACAhX擾܂B
//*		   : lanio       LANIOԍ
//*		         macaddress  MACAhX擾obt@ւ̃|C^(6byteKv)
//***************************************************************************
DECLSPEC LELanioGetMacAddress(int lanio, unsigned char *macaddress);

//***************************************************************************
//*		LANIOIDԍ擾܂B
//*		   : lanio   LANIOԍ
//*		         id      LANIOID擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetId(int lanio, int *id);

//***************************************************************************
//*		LANIÕf擾܂B
//*		   : lanio   LANIOԍ
//*		         model   LANIÕf擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetModel(int lanio, int *model);

//***************************************************************************
//*		LANIOɑ΂IDƃfԍ₵܂B
//*		   : lanio   LANIOԍ
//*		         id      LANIOID擾obt@ւ̃|C^
//*		         model   LANIÕf擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioRequestIdModel(int lanio, int *id, int *model);

//***************************************************************************
//* LANIOڑ֐
//***************************************************************************

//***************************************************************************
//*		LELanioSearchɂĔꂽԂw肵Đڑ܂B
//*		   : lanio   LANIOԍ
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnect(int lanio);

//***************************************************************************
//*		IDƃfw肵Đڑ܂B
//*		   : id      LANIOIDԍ
//*		         model   LANIÕf
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnectByIdModel(int id, int model);

//***************************************************************************
//*		IPAhXw肵Đڑ܂B
//*		   : ipaddress   IPAhXobt@ւ̃|C^
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnectByIpAddress(char *ipaddress);

//***************************************************************************
//*		MACAhXw肵Đڑ܂B
//*		   : macaddress  MACAhXobt@ւ̃|C^
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnectByMacAddress(unsigned char *macaddress);

//***************************************************************************
//*		IPAhXURLw肵Đڑ܂B
//*		   : address IPAhX܂urlobt@ւ̃|C^
//*		         msec    ^CAEgԁiP mbj
//*		߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LELanioConnectDirect(char *address, int msec = 1000);

//***************************************************************************
//* LANIOؒf֐
//***************************************************************************

//***************************************************************************
DECLSPEC LELanioClose(hLANIO handle);
//*		LANIOƂ̐ڑؒf܂B
//*		   : handle  LANIOnh
//***************************************************************************

//***************************************************************************
//* o͊֐
//***************************************************************************

//***************************************************************************
//*		LANIODO𑀍삵܂B_Pʂ̑Ɏgp܂B
//*		   : handle  LANIOnh
//*		         pio     삷DO|[gԍBDO1=0ADO2=1...
//*		         active  ONȂ1AOFFȂ0
//***************************************************************************
DECLSPEC LELanioOutPio(hLANIO handle, int pio, BOOL active);

//***************************************************************************
//*		LANIODO𑀍삵܂BSĂDOɑ΂Ăɑ삷鎞Ɏgp܂B
//*		   : handle  LANIOnh
//*		         piobit  DO|[g̐ݒBŉʃrbgDO1ADO2...ɑΉ܂
//***************************************************************************
DECLSPEC LELanioOutPioAll(hLANIO handle, int piobit);

//***************************************************************************
//*		LANIODI擾܂B_Pʂ̎擾Ɏgp܂B
//*		   : handle  LANIOnh
//*		         pio     擾DI|[gԍBDI1=0ADI2=1...ɑΉ܂
//*		         active  ONȂ1AOFFȂ0obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioInPio(hLANIO handle, int pio, BOOL *active);

//***************************************************************************
//*		LANIODI擾܂BSĂDIɑ΂ĂɎ擾鎞Ɏgp܂B
//*		   : handle  LANIOnh
//*		         piobit  DI|[g̓eobt@ւ̃|C^
//*		                 ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LELanioInPioAll(hLANIO handle, int *piobit);

//***************************************************************************
//*		LANIǑ݂DOԂ擾܂B_Pʂ̎擾Ɏgp܂B
//*		   : handle  LANIOnh
//*		         pio     擾DO|[gԍBDO1=0ADO2=1...ɑΉ܂
//*		         active  ONȂ1AOFFȂ0obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetOut(hLANIO handle, int pio, BOOL *active);

//***************************************************************************
//*		LANIǑ݂DOԂ擾܂BSĂDOɑ΂ĂɎ擾鎞Ɏgp܂B
//*		   : handle  LANIOnh
//*		         piobit  DO|[g̓eobt@ւ̃|C^
//*		                 ŉʃrbgDO1ADO2...
//***************************************************************************
DECLSPEC LELanioGetOutAll(hLANIO handle, int *piobit);

//***************************************************************************
//*		LANIȌo͒[qON/OFF̊Jn/~s܂
//*		   : handle  LANIOnh
//*		         active  ON/OFFJn=0ȊOA~=0
//***************************************************************************
DECLSPEC LELanioSetAutoSwitchingActive(hLANIO handle, BOOL active);

//***************************************************************************
//*		LANIȌo͒[qON/OFF̊Jn/~ݒ擾܂
//*		   : handle  LANIOnh
//*		         active  ON/OFFԂobt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetAutoSwitchingActive(hLANIO handle, BOOL *active);

//***************************************************************************
//*		LANIȌo͒[qON/OFF̎ݒ肵܂
//*		   : handle  LANIOnh
//*		         msec    iP mbj
//***************************************************************************
DECLSPEC LELanioSetAutoSwitchingTime(hLANIO handle, int msec);

//***************************************************************************
//*		LANIȌo͒[qON/OFF̎ݒ擾܂
//*		   : handle  LANIOnh
//*		         msec    iP mbjobt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetAutoSwitchingTime(hLANIO handle, int *msec);

//***************************************************************************
//*		LANIȌo͒[qON/OFFsDOݒ肵܂B
//*		   : handle  LANIOnh
//*		         msec    ŉʃrbgADO1`DO5ŎON/OFFs[q1
//***************************************************************************
DECLSPEC LELanioSetAutoSwitchingPio(hLANIO handle, int autoswdo);

//***************************************************************************
//*		LANIȌo͒[qON/OFFsDOݒ擾܂
//*		   : handle  LANIOnh
//*		         msec    ON/OFFsDOݒ擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LELanioGetAutoSwitchingPio(hLANIO handle, int *autoswdo);

//***************************************************************************
//*		LANIO̖ʐMԂɂȂ̐ڑێԂݒ肷
//*		   : handle  LANIOnh
//*		         time    
//*		                 0x00:ؒf 0x04: 3sec  0x08:50sec  0x0c:10min
//*		                 0x01:300ms    0x05: 5sec  0x09: 1min  0x0d:30min
//*		                 0x02:500ms    0x06:10sec  0x0a: 3min  0x0e:50min
//*		                 0x03: 1sec    0x07:30sec  0x0b: 5min  0x0f:
//***************************************************************************
DECLSPEC LELanioSetDisconnectionTime(hLANIO handle, int time);

//***************************************************************************
//*		LANIO̖ʐMԂɂȂ̐ڑێԂ擾
//*		   : handle  LANIOnh
//*		         time    Ԃ擾obt@ւ̃|C^
//*		                 0x00:ؒf 0x04: 3sec  0x08:50sec  0x0c:10min
//*		                 0x01:300ms    0x05: 5sec  0x09: 1min  0x0d:30min
//*		                 0x02:500ms    0x06:10sec  0x0a: 3min  0x0e:50min
//*		                 0x03: 1sec    0x07:30sec  0x0b: 5min  0x0f:
//***************************************************************************
DECLSPEC LELanioGetDisconnectionTime(hLANIO handle, int *time);

//***************************************************************************
//*		LANIÕ`^O̊Ԃݒ肷
//*		   : handle  LANIOnh
//*		         time    (msP 4ms`20msj
//***************************************************************************
DECLSPEC LELanioSetDiDetectTime(hLANIO handle, int time);

//***************************************************************************
//*		LANIÕ`^O̊Ԃ擾
//*		   : handle  LANIOnh
//*		         time    Ԃ擾obt@ւ̃|C^(msP 4ms`20msj
//***************************************************************************
DECLSPEC LELanioGetDiDetectTime(hLANIO handle, int *time);

//***************************************************************************
//*		LANIÕ[A[gs͒[qݒ肵܂
//*		   : handle  LANIOnh
//*		         enable  [A[gsrbg1Ŏw
//*		                 ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LELanioSetDiMailEnable(hLANIO handle, int enable);

//***************************************************************************
//*		LANIÕ[A[gs͒[q擾܂
//*		   : handle  LANIOnh
//*		         enable  [A[gsrbg1Ŏw
//*		                 ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LELanioGetDiMailEnable(hLANIO handle, int *enable);

//***************************************************************************
//*		LANIÕ[A[gs_Ԃݒ肵܂
//*		   : handle  LANIOnh
//*		         logic   オGbWŃ[A[gsrbg1Ŏw
//*		                 ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LELanioSetDiMailLogic(hLANIO handle, int logic);

//***************************************************************************
//*		LANIÕ[A[gs_Ԃݒ肵܂
//*		   : handle  LANIOnh
//*		         logic   オGbWŃ[A[gsrbg1Ŏw
//*		                 ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LELanioGetDiMailLogic(hLANIO handle, int *logic);

